api/urls.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

from django.conf import settings
from django.urls import include, path
from rest_framework import routers

from .viewsets import UserViewSet

# Routers provide an easy way of automatically determining the URL conf.
# Register each app API router and user viewset
router = routers.DefaultRouter()
router.register('user', UserViewSet)

if "logs" in settings.INSTALLED_APPS:
    from logs.api.urls import register_logs_urls
    register_logs_urls(router, "logs")

if "participation" in settings.INSTALLED_APPS:
    from participation.api.urls import register_participation_urls
    register_participation_urls(router, "participation")

if "registration" in settings.INSTALLED_APPS:
    from registration.api.urls import register_registration_urls
    register_registration_urls(router, "registration")

app_name = 'api'

# Wire up our API using automatic URL routing.
# Additionally, we include login URLs for the browsable API.
urlpatterns = [
    path('', include(router.urls)),
    path('api-auth/', include('rest_framework.urls', namespace='rest_framework')),
]

chat/urls.py
# Copyright (C) 2024 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

from django.contrib.auth.views import LoginView, LogoutView
from django.urls import path
from django.utils.translation import gettext_lazy as _
from tfjm.views import LoginRequiredTemplateView

app_name = 'chat'

urlpatterns = [
    path('', LoginRequiredTemplateView.as_view(template_name="chat/chat.html",
                                               extra_context={'title': _("Chat")}), name='chat'),
    path('fullscreen/', LoginRequiredTemplateView.as_view(template_name="chat/fullscreen.html", login_url='chat:login'),
         name='fullscreen'),
    path('login/', LoginView.as_view(template_name="chat/login.html"), name='login'),
    path('logout/', LogoutView.as_view(next_page='chat:fullscreen'), name='logout'),
]

tfjm/urls.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

"""tfjm URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/3.0/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.conf import settings
from django.contrib import admin
from django.urls import include, path
from django.utils.translation import gettext_lazy as _
from django.views.defaults import bad_request, page_not_found, permission_denied, server_error
from django.views.generic import TemplateView
from participation.views import MotivationLetterView
from registration.views import HealthSheetView, ParentalAuthorizationView, PhotoAuthorizationView, \
    ReceiptView, SolutionView, VaccineSheetView, WrittenReviewView

from .views import AdminSearchView

urlpatterns = [
    path('', TemplateView.as_view(template_name=f"index_{settings.TFJM_APP.lower()}.html",
                                  extra_context={'title': _("Home")}),
         name='index'),
    path('about/', TemplateView.as_view(template_name="about.html"), name='about'),
    path('i18n/', include('django.conf.urls.i18n')),
    path('admin/doc/', include('django.contrib.admindocs.urls')),
    path('admin/', admin.site.urls, name="admin"),
    path('accounts/', include('django.contrib.auth.urls')),
    path('search/', AdminSearchView.as_view(), name="haystack_search"),

    path('api/', include('api.urls')),
    path('chat/', include('chat.urls')),
    path('draw/', include('draw.urls')),
    path('participation/', include('participation.urls')),
    path('registration/', include('registration.urls')),

    path('media/authorization/photo/<str:filename>/', PhotoAuthorizationView.as_view(),
         name='photo_authorization'),
    path('media/authorization/health/<str:filename>/', HealthSheetView.as_view(),
         name='health_sheet'),
    path('media/authorization/vaccine/<str:filename>/', VaccineSheetView.as_view(),
         name='vaccine_sheet'),
    path('media/authorization/parental/<str:filename>/', ParentalAuthorizationView.as_view(),
         name='parental_authorization'),
    path('media/authorization/receipt/<str:filename>/', ReceiptView.as_view(),
         name='receipt'),
    path('media/authorization/motivation_letters/<str:filename>/', MotivationLetterView.as_view(),
         name='motivation_letter'),

    path('media/solutions/<str:filename>/', SolutionView.as_view(),
         name='solution'),
    path('media/reviews/<str:filename>/', WrittenReviewView.as_view(),
         name='reviews'),
]

if settings.DEBUG:
    # Serve static files in DEBUG mode
    import django.contrib.staticfiles.urls
    urlpatterns += django.contrib.staticfiles.urls.urlpatterns

handler400 = bad_request
handler403 = permission_denied
handler404 = page_not_found
handler500 = server_error

chat/models.py
# Copyright (C) 2024 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

from asgiref.sync import sync_to_async
from django.contrib.auth.models import User
from django.db import models
from django.db.models import Q, QuerySet
from django.utils.text import format_lazy
from django.utils.translation import gettext_lazy as _
from participation.models import Pool, Team, Tournament
from registration.models import ParticipantRegistration, Registration, VolunteerRegistration
from tfjm.permissions import PermissionType


class Channel(models.Model):
    """
    Ce modèle représente un canal de chat, défini par son nom, sa catégorie, les permissions de lecture et d'écriture
    requises pour accéder au canal, et éventuellement un tournoi, une poule ou une équipe associée.
    """

    class ChannelCategory(models.TextChoices):
        GENERAL = 'general', _("General channels")
        TOURNAMENT = 'tournament', _("Tournament channels")
        TEAM = 'team', _("Team channels")
        PRIVATE = 'private', _("Private channels")

    name = models.CharField(
        max_length=255,
        verbose_name=_("name"),
        help_text=_("Visible name of the channel."),
    )

    category = models.CharField(
        max_length=255,
        verbose_name=_("category"),
        choices=ChannelCategory,
        default=ChannelCategory.GENERAL,
        help_text=_("Category of the channel, between general channels, tournament-specific channels, team channels "
                    "or private channels. Will be used to sort channels in the channel list."),
    )

    read_access = models.CharField(
        max_length=16,
        verbose_name=_("read permission"),
        choices=PermissionType,
        help_text=_("Permission type that is required to read the messages of the channels."),
    )

    write_access = models.CharField(
        max_length=16,
        verbose_name=_("write permission"),
        choices=PermissionType,
        help_text=_("Permission type that is required to write a message to a channel."),
    )

    tournament = models.ForeignKey(
        'participation.Tournament',
        on_delete=models.CASCADE,
        blank=True,
        null=True,
        default=None,
        verbose_name=_("tournament"),
        related_name='chat_channels',
        help_text=_("For a permission that concerns a tournament, indicates what is the concerned tournament."),
    )

    pool = models.ForeignKey(
        'participation.Pool',
        on_delete=models.CASCADE,
        blank=True,
        null=True,
        default=None,
        verbose_name=_("pool"),
        related_name='chat_channels',
        help_text=_("For a permission that concerns a pool, indicates what is the concerned pool."),
    )

    team = models.ForeignKey(
        'participation.Team',
        on_delete=models.CASCADE,
        blank=True,
        null=True,
        default=None,
        verbose_name=_("team"),
        related_name='chat_channels',
        help_text=_("For a permission that concerns a team, indicates what is the concerned team."),
    )

    private = models.BooleanField(
        verbose_name=_("private"),
        default=False,
        help_text=_("If checked, only users who have been explicitly added to the channel will be able to access it."),
    )

    invited = models.ManyToManyField(
        'auth.User',
        verbose_name=_("invited users"),
        related_name='+',
        blank=True,
        help_text=_("Extra users who have been invited to the channel, "
                    "in addition to the permitted group of the channel."),
    )

    def get_visible_name(self, user: User) -> str:
        """
        Renvoie le nom du channel tel qu'il est visible pour l'utilisateur⋅rice donné.
        Dans le cas d'un canal classique, renvoie directement le nom.
        Dans le cas d'un canal privé, renvoie la liste des personnes membres du canal,
        à l'exception de la personne connectée, afin de ne pas afficher son propre nom.
        Dans le cas d'un chat avec uniquement soi-même, on affiche que notre propre nom.
        """
        if self.private:
            # Le canal est privé, on renvoie la liste des personnes membres du canal
            # à l'exception de soi-même (sauf si on est la seule personne dans le canal)
            users = [f"{u.first_name} {u.last_name}" for u in self.invited.all() if u != user] \
                    or [f"{user.first_name} {user.last_name}"]
            return ", ".join(users)
        # Le canal est public, on renvoie directement le nom
        return self.name

    def __str__(self):
        return str(format_lazy(_("Channel {name}"), name=self.name))

    @staticmethod
    async def get_accessible_channels(user: User, permission_type: str = 'read') -> QuerySet["Channel"]:
        """
        Renvoie les canaux auxquels l'utilisateur⋅rice donné a accès, en lecture ou en écriture.

        Types de permissions :
        ANONYMOUS : Tout le monde, y compris les utilisateur⋅rices non connecté⋅es
        AUTHENTICATED : Toustes les utilisateur⋅rices connecté⋅es
        VOLUNTEER : Toustes les bénévoles
        TOURNAMENT_MEMBER : Toustes les membres d'un tournoi donné (orgas, juré⋅es, participant⋅es)
        TOURNAMENT_ORGANIZER : Les organisateur⋅rices d'un tournoi donné
        TOURNAMENT_JURY_PRESIDENT : Les organisateur⋅rices et les président⋅es de jury d'un tournoi donné
        JURY_MEMBER : Les membres du jury d'une poule donnée, ou les organisateur⋅rices du tournoi
        POOL_MEMBER : Les membres du jury et les participant⋅es d'une poule donnée, ou les organisateur⋅rices du tournoi
        TEAM_MEMBER : Les membres d'une équipe donnée
        PRIVATE : Les utilisateur⋅rices explicitement invité⋅es
        ADMIN : Les utilisateur⋅rices administrateur⋅rices (qui ont accès à tout)

        Les canaux privés sont utilisés pour les messages privés, et ne sont pas affichés aux admins.

        :param user: L'utilisateur⋅rice dont on veut récupérer la liste des canaux.
        :param permission_type: Le type de permission concerné (read ou write).
        :return: Le Queryset des canaux autorisés.
        """
        permission_type = 'write_access' if 'write' in permission_type.lower() else 'read_access'

        qs = Channel.objects.none()
        if user.is_anonymous:
            # Les utilisateur⋅rices non connecté⋅es ont accès aux canaux publics pour toustes
            return Channel.objects.filter(**{permission_type: PermissionType.ANONYMOUS})

        # Les utilisateur⋅rices connecté⋅es ont accès aux canaux publics pour les personnes connectées
        qs |= Channel.objects.filter(**{permission_type: PermissionType.AUTHENTICATED})
        registration = await Registration.objects.prefetch_related('user').aget(user_id=user.id)

        if registration.is_admin:
            # Les administrateur⋅rices ont accès à tous les canaux, sauf les canaux privés sont iels ne sont pas membres
            return Channel.objects.prefetch_related('invited').exclude(~Q(invited=user) & Q(private=True)).all()

        if registration.is_volunteer:
            registration = await VolunteerRegistration.objects \
                .prefetch_related('jury_in__tournament', 'organized_tournaments').aget(user_id=user.id)

            # Les bénévoles ont accès aux canaux pour bénévoles
            qs |= Channel.objects.filter(**{permission_type: PermissionType.VOLUNTEER})

            # Iels ont accès aux tournois dont iels sont organisateur⋅rices ou juré⋅es
            # pour la permission TOURNAMENT_MEMBER
            qs |= Channel.objects.filter(Q(tournament__in=registration.interesting_tournaments),
                                         **{permission_type: PermissionType.TOURNAMENT_MEMBER})

            # Iels ont accès aux canaux pour les organisateur⋅rices des tournois dont iels sont organisateur⋅rices
            # pour la permission TOURNAMENT_ORGANIZER
            qs |= Channel.objects.filter(Q(tournament__in=registration.organized_tournaments.all()),
                                         **{permission_type: PermissionType.TOURNAMENT_ORGANIZER})

            # Iels ont accès aux canaux pour les organisateur⋅rices et président⋅es de jury des tournois dont iels sont
            # organisateur⋅rices ou juré⋅es pour la permission TOURNAMENT_JURY_PRESIDENT
            qs |= Channel.objects.filter(Q(tournament__pools__in=registration.pools_presided.all())
                                         | Q(tournament__in=registration.organized_tournaments.all()),
                                         **{permission_type: PermissionType.TOURNAMENT_JURY_PRESIDENT})

            # Iels ont accès aux canaux pour les juré⋅es des poules dont iels sont juré⋅es
            # ou les organisateur⋅rices des tournois dont iels sont organisateur⋅rices
            # pour la permission JURY_MEMBER
            qs |= Channel.objects.filter(Q(pool__in=registration.jury_in.all())
                                         | Q(pool__tournament__in=registration.organized_tournaments.all())
                                         | Q(pool__tournament__pools__in=registration.pools_presided.all()),
                                         **{permission_type: PermissionType.JURY_MEMBER})

            # Iels ont accès aux canaux pour les juré⋅es et participant⋅es des poules dont iels sont juré⋅es
            # ou les organisateur⋅rices des tournois dont iels sont organisateur⋅rices
            # pour la permission POOL_MEMBER
            qs |= Channel.objects.filter(Q(pool__in=registration.jury_in.all())
                                         | Q(pool__tournament__in=registration.organized_tournaments.all())
                                         | Q(pool__tournament__pools__in=registration.pools_presided.all()),
                                         **{permission_type: PermissionType.POOL_MEMBER})
        else:
            registration = await ParticipantRegistration.objects \

chat/templates/chat/chat.html
{% extends "base.html" %}

{% load static %}
{% load i18n %}
{% load pipeline %}

{% block extracss %}
    {# Webmanifest PWA permettant l'installation de l'application sur un écran d'accueil, pour navigateurs supportés #}
    {% if TFJM.APP == "TFJM" %}
        <link rel="manifest" href="{% static "tfjm/chat_tfjm.webmanifest" %}">
    {% elif TFJM.APP == "ETEAM" %}
        <link rel="manifest" href="{% static "tfjm/chat_eteam.webmanifest" %}">
    {% endif %}
{% endblock %}

{% block content-title %}{% endblock %}

{% block content %}
    {% include "chat/content.html" %}
{% endblock %}

{% block extrajavascript %}
    {# Ce script contient toutes les données pour la gestion du chat. #}
    {% javascript 'chat' %}
{% endblock %}

chat/templates/chat/content.html
{% load i18n %}

<noscript>
    {# Le chat fonctionne à l'aide d'un script JavaScript, sans JavaScript activé il n'est pas possible d'utiliser le chat. #}
    {% trans "JavaScript must be enabled on your browser to access chat." %}
</noscript>
<div class="offcanvas offcanvas-start" tabindex="-1" id="channelSelector" aria-labelledby="offcanvasTitle">
    <div class="offcanvas-header">
        {# Titre du sélecteur de canaux #}
        <h3 class="offcanvas-title" id="offcanvasTitle">{% trans "Chat channels" %}</h3>
        <button type="button" class="btn-close" data-bs-dismiss="offcanvas" aria-label="Close"></button>
    </div>
    <div class="offcanvas-body">
        {# Contenu du sélecteur de canaux #}
        <div class="form-switch form-switch">
            <input class="form-check-input" type="checkbox" role="switch" id="sort-by-unread-switch">
            <label class="form-check-label" for="sort-by-unread-switch">{% trans "Sort by unread messages" %}</label>
        </div>
        <ul class="list-group list-group-flush" id="nav-channels-tab">
            {# Liste des différentes catégories, avec les canaux par catégorie #}
            <li class="list-group-item d-none">
                {# Canaux généraux #}
                <h4>{% trans "General channels" %}</h4>
                <ul class="list-group list-group-flush" id="nav-general-channels-tab"></ul>
            </li>
            <li class="list-group-item d-none">
                {# Canaux liés à un tournoi #}
                <h4>{% trans "Tournament channels" %}</h4>
                <ul class="list-group list-group-flush" id="nav-tournament-channels-tab"></ul>
            </li>
            <li class="list-group-item d-none">
                {# Canaux d'équipes #}
                <h4>{% trans "Team channels" %}</h4>
                <ul class="list-group list-group-flush" id="nav-team-channels-tab"></ul>
            </li>
            <li class="list-group-item d-none">
                {# Échanges privés #}
                <h4>{% trans "Private channels" %}</h4>
                <ul class="list-group list-group-flush" id="nav-private-channels-tab"></ul>
            </li>
        </ul>
    </div>
</div>

<div class="alert alert-info d-none" id="alert-download-chat-app">
    {# Lorsque l'application du chat est installable (par exemple sur un Chrome sur Android), on affiche le message qui indique que c'est bien possible. #}
    {% trans "You can install a shortcut to the chat on your home screen using the download button on the header." %}
</div>

{# Conteneur principal du chat. #}
{# Lorsque le chat est en plein écran, on le place en coordonnées absolues, occupant tout l'espace de l'écran. #}
<div class="card tab-content w-100 mh-100{% if request.GET.fullscreen == '1' or fullscreen %} position-absolute top-0 start-0 vh-100 z-3{% endif %}"
     style="height: 95vh" id="chat-container">
    <div class="card-header">
        <h3>
        {% if fullscreen %}
            {# Lorsque le chat est en plein écran, on affiche le bouton de déconnexion. #}
            {# Le bouton de déconnexion doit être présent dans un formulaire. Le formulaire doit inclure toute la ligne. #}
            <form action="{% url 'chat:logout' %}" method="post">
                {% csrf_token %}
        {% endif %}
            {# Bouton qui permet d'ouvrir le sélecteur de canaux #}
            <button class="navbar-toggler" type="button" data-bs-toggle="offcanvas" data-bs-target="#channelSelector"
                    aria-controls="channelSelector" aria-expanded="false" aria-label="Toggle channel selector">
                <span class="navbar-toggler-icon"></span>
            </button>

            <span id="channel-title"></span> {# Titre du canal sélectionné #}
            {% if not fullscreen %}
                {# Dans le cas où on est pas uniquement en plein écran (cas de l'application), on affiche les boutons pour passer en ou quitter le mode plein écran. #}
                <button class="btn float-end" type="button" onclick="toggleFullscreen()" title="{% trans "Toggle fullscreen mode" %}">
                    <i class="fas fa-expand"></i>
                </button>
            {% else %}
                {# Le bouton de déconnexion n'est affiché que sur l'application. #}
                <button class="btn float-end" title="{% trans "Log out" %}">
                    <i class="fas fa-sign-out-alt"></i>
                </button>
            {% endif %}
            {# On affiche le bouton d'installation uniquement dans le cas où l'application est installable sur l'écran d'accueil. #}
            <button class="btn float-end d-none" type="button" id="install-app-home-screen" title="{% trans "Install app on home screen" %}">
                <i class="fas fa-download"></i>
            </button>
            {% if fullscreen %}
                </form>
            {% endif %}
        </h3>
    </div>

    {# Contenu de la carte, contenant la liste des messages. La liste des messages est affichée à l'envers pour avoir un scroll plus cohérent. #}
    <div class="card-body d-flex flex-column-reverse flex-grow-0 overflow-y-scroll" id="chat-messages">
        {# Correspond à la liste des messages à afficher. #}
        <ul class="list-group list-group-flush" id="message-list"></ul>
        {# S'il y a des messages à récupérer, on affiche un lien qui permet de récupérer les anciens messages. #}
        <div class="text-center d-none" id="fetch-previous-messages">
            <a href="#" class="nav-link" onclick="event.preventDefault(); fetchPreviousMessages()">
                {% trans "Fetch previous messages…" %}
            </a>
            <hr>
        </div>
    </div>
    
    {# Pied de la carte, contenant le formulaire pour envoyer un message. #}
    <div class="card-footer mt-auto">
        {# Lorsqu'on souhaite envoyer un message, on empêche le formulaire de s'envoyer et on envoie le message par websocket. #}
        <form onsubmit="event.preventDefault(); sendMessage()">
            <div class="input-group">
                <label for="input-message" class="input-group-text">
                    <i class="fas fa-comment"></i>
                </label>
                {# Affichage du contrôleur de texte pour rédiger le message à envoyer. #}
                <input type="text" class="form-control" id="input-message" placeholder="{% trans "Send message…" %}" autofocus autocomplete="off">
                <button class="input-group-text btn btn-success" type="submit">
                    <i class="fas fa-paper-plane"></i>
                </button>
            </div>
        </form>
    </div>
</div>

<script>
    {# Récupération de l'utilisateur⋅rice courant⋅e afin de pouvoir effectuer des tests plus tard. #}
    const USER_ID = {{ request.user.id }}
    {# Récupération du statut administrateur⋅rice de l'utilisateur⋅rice connecté⋅e afin de pouvoir effectuer des tests plus tard. #}
    const IS_ADMIN = {{ request.user.registration.is_admin|yesno:"true,false" }}
</script>

chat/templates/chat/fullscreen.html
{% load i18n pipeline static %}

<!DOCTYPE html>
{% get_current_language as LANGUAGE_CODE %}{% get_current_language_bidi as LANGUAGE_BIDI %}
<html lang="{{ LANGUAGE_CODE|default:"fr" }}" {% if LANGUAGE_BIDI %}dir="rtl"{% endif %}>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    {% if TFJM.APP == "TFJM" %}
        <title>{% trans "TFJM² Chat" %}</title>
        <meta name="description" content="{% trans "TFJM² Chat" %}">
    {% elif TFJM.APP == "ETEAM" %}
        <title>{% trans "ETEAM Chat" %}</title>
        <meta name="description" content="{% trans "ETEAM Chat" %}">
    {% endif %}

    {# Favicon #}
    <link rel="shortcut icon" href="{% static "favicon.ico" %}">
    <meta name="theme-color" content="#ffffff">

    {# Bootstrap CSS #}
    <link href="{% static "bootstrap/css/bootstrap.min.css" %}" rel="stylesheet" type="text/css">
    {# Fontawesome CSS #}
    <link href="{% static "fontawesome/css/all.min.css" %}" rel="stylesheet" type="text/css">
    <link href="{% static "fontawesome/css/v4-shims.css" %}">
    {# bootstrap-select CSS #}
    <link href="{% static "bootstrap-select/css/bootstrap-select.min.css" %}" rel="stylesheet" type="text/css">

    {# Bootstrap JavaScript #}
    <script type="application/javascript" src="{% static "bootstrap/js/bootstrap.bundle.min.js" %}" charset="utf-8"></script>

    {# Webmanifest PWA permettant l'installation de l'application sur un écran d'accueil, pour navigateurs supportés #}
    {% if TFJM.APP == "TFJM" %}
        <link rel="manifest" href="{% static "tfjm/chat_tfjm.webmanifest" %}">
    {% elif TFJM.APP == "ETEAM" %}
        <link rel="manifest" href="{% static "tfjm/chat_eteam.webmanifest" %}">
    {% endif %}
</head>
<body class="d-flex w-100 h-100 flex-column">
{% include "chat/content.html" with fullscreen=True %}

{# Inclusion du script permettant de gérer le thème sombre et le thème clair #}
{% javascript 'theme' %}
{# Inclusion du script gérant le chat #}
{% javascript 'chat' %}
</body>
</html>

chat/templates/chat/login.html
{% load i18n pipeline static %}

<!DOCTYPE html>
{% get_current_language as LANGUAGE_CODE %}{% get_current_language_bidi as LANGUAGE_BIDI %}
<html lang="{{ LANGUAGE_CODE|default:"fr" }}" {% if LANGUAGE_BIDI %}dir="rtl"{% endif %}>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <title>
        {% trans "Chat" %} - {% trans "Log in" %}
    </title>
    <meta name="description" content="{% trans "Chat" %}">

    {# Favicon #}
    <link rel="shortcut icon" href="{% static "favicon.ico" %}">
    <meta name="theme-color" content="#ffffff">

    {# Bootstrap CSS #}
    <link href="{% static "bootstrap/css/bootstrap.min.css" %}" rel="stylesheet" type="text/css">
    {# Fontawesome CSS #}
    <link href="{% static "fontawesome/css/all.min.css" %}" rel="stylesheet" type="text/css">
    <link href="{% static "fontawesome/css/v4-shims.css" %}">

    {# Bootstrap JavaScript #}
    <script type="application/javascript" src="{% static "bootstrap/js/bootstrap.bundle.min.js" %}" charset="utf-8"></script>

    {# Webmanifest PWA permettant l'installation de l'application sur un écran d'accueil, pour navigateurs supportés #}
    {% if TFJM.APP == "TFJM" %}
        <link rel="manifest" href="{% static "tfjm/chat_tfjm.webmanifest" %}">
    {% elif TFJM.APP == "ETEAM" %}
        <link rel="manifest" href="{% static "tfjm/chat_eteam.webmanifest" %}">
    {% endif %}
</head>
<body class="d-flex w-100 h-100 flex-column">
    <div class="container">
        <h1>{% trans "Log in" %}</h1>
        {% include "registration/includes/login.html" %}
    </div>

{# Inclusion du script permettant de gérer le thème sombre et le thème clair #}
{% javascript 'theme' %}
</body>
</html>